//
//  AgentView.m
//  Creatures
//
//  Created by Lenka on 21/12/2009.
//  Copyright 2009 Lenka Pitonakova. All rights reserved.
//

#import "DynObjView.h"
#import "DynObjController.h"
#import "Texture2D.h"
#import "World.h"

@implementation DynObjView

@synthesize m_bSelected;

- (id) initViewWithController: (DynObjController*)control_ {
	[super init];
	m_pController = control_;
	m_bSelected = false;
	return self;
}
- (void) RenderAt: (CGPoint)pos_ rot:(CGFloat)rot_ txtrId:(Byte)txtrId_ uCoordins:(CGPoint)uc_ vCoordins:(CGPoint)vc_ {
	CGPoint uCoords = uc_;
	//------------- adjust U texture coordinates if selected, use slice on the right:
	if (m_bSelected) {
		if (![m_pController GetIsMoving]) {
			uCoords = CGPointMake(uc_.x+0.5,uc_.y + 0.5);
		}
		
	}
	DrawSpriteAtWithUV(txtrId_,pos_,rot_, uCoords, vc_);
}
/* HitTest
 - returns true if point is inside of the view
*/
- (BOOL) HitTest: (CGPoint)withPt selfPos:(CGPoint)pos_ selfSize:(CGPoint)size_ {
	BOOL hit = false;
	if (withPt.y > pos_.y - size_.y/2 && withPt.y < pos_.y + size_.y/2) {
		if (withPt.x > pos_.x - size_.x/2 && withPt.x < pos_.x + size_.x/2) {
			hit = true;
		}
	}
	return hit;
}

#pragma mark =============================== USER INTERACTION

- (void) HandleTouchesBeginAt:(CGPoint)pos_ selfPos:(CGPoint)selfPos_ selfSize:(CGPoint)selfSize_ {
	//-------------------- test if object has been clicked on:
	if ([self HitTest:pos_ selfPos:selfPos_ selfSize:selfSize_]) {
		[self UserStartTouchInside];
	} else {
		//---------------- object hasn't been clicke on:
		[self UserStartTouchOutside];
		
	}
	//---------------- register self in the global array as selected:
	if (m_bSelected) {
		g_bSelectedUnits[m_pController.m_iId] = true;
	}
			
}

- (void) UserStartTouchInside {
	[m_pController.m_pWorld UnselectAllOtherObjects:m_pController.m_iId];
	m_bSelected = !m_bSelected;
	
}
- (void) UserStartTouchOutside {

}

- (void) HandleTouchesMovedAt:(CGPoint)pos_ selfPos:(CGPoint)selfPos_ selfSize:(CGPoint)selfSize_{
	
}

- (void) HandleTouchesEndedAt:(CGPoint)pos_ selfPos:(CGPoint)selfPos_ selfSize:(CGPoint)selfSize_{
}



@end
