//
//  UnitView.m
//  Creatures
//
//  Created by Lenka on 08/01/2010.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "UnitView.h"
#import "UnitController.h"
#import "Vector.h"
#import "World.h"


@implementation UnitView


- (id) initViewWithController: (UnitController*)control_ {
	[super initViewWithController:control_];
	return self;
}


- (void) RenderAt: (CGPoint)pos_ rot:(CGFloat)rot_ txtrId: (Byte)txtrId_ uCoordins:(CGPoint)uc_ vCoordins:(CGPoint)vc_ eyes:(Byte)eyesCol_ {
	//-------- draw body based on coordinates set in constructor
	[super RenderAt:pos_ rot:rot_ txtrId:txtrId_ uCoordins:uc_ vCoordins:vc_];
	//--------- render eyes:
	CGPoint eyesU = CGPointMake(0,0.5);
	CGPoint eyesV;
	switch(eyesCol_) {
		case COL_GREEN:
			eyesV = CGPointMake(0,0.25);
			break;
		case COL_BROWN:
			eyesV = CGPointMake(0.25,0.5);
			break;
		case COL_PURPLE:
			eyesV = CGPointMake(0.5,0.75);
			break;
		case COL_ORANGE:
			eyesV = CGPointMake(0.75,1);
			break;
	}
	
	CGPoint eyesPos;
	//------------------ decide about eyes' U coordinates and position 
	if (m_bSelected && ![m_pController GetIsMoving]) {
		eyesU = CGPointMake(0.5,1);
		eyesPos= AddVectors(m_pController.m_ptPos, CGPointMake(
																	-cos(m_pController.m_fRot*PI/180)*5,
																	-sin(m_pController.m_fRot*PI/180)*5));
	} else {
		eyesPos= AddVectors(m_pController.m_ptPos, CGPointMake(
															   cos(m_pController.m_fRot*PI/180)*25,
															   sin(m_pController.m_fRot*PI/180)*25));
	}
	DrawSpriteAtWithUV(TEX_UNITS_EYES, eyesPos, rot_, eyesU, eyesV);
	
}


- (void) UserStartTouchInside {
	[super UserStartTouchInside];
	[m_pController UserOrder:UORDER_NONE atLocation:CGPointMake(0,0) withObject:NULL];
}


- (void) HandleTouchesMovedAt:(CGPoint)pos_ selfPos:(CGPoint)selfPos_ selfSize:(CGPoint)selfSize_{
	if (!m_bSelected && g_bSelectedUnits[m_pController.m_iId] == true) {
		m_bSelected = true;
	}
}


- (void) HandleTouchesEndedAt:(CGPoint)pos_ selfPos:(CGPoint)selfPos_ selfSize:(CGPoint)selfSize_{
	if (m_bSelected && !GetIsAnotherObjectSelected(m_pController.m_iId)) {
		//----- test if touch ended on another unit, if yes multiply order
		int otherDynObjPos = [m_pController.m_pWorld GetDynObjIdAt:pos_];
		NSInteger type = [m_pController.m_pWorld GetDynObjWithId:otherDynObjPos].m_iType;
		if (otherDynObjPos > -1 &&  type == OBJ_UNIT && otherDynObjPos != m_pController.m_iId) {
			[m_pController UserOrder:UORDER_BREED atLocation:pos_ withObject:[m_pController.m_pWorld GetDynObjWithId:otherDynObjPos]];
		} else {
		//---------- if not, move order
			[m_pController UserOrder:UORDER_MOVE atLocation:pos_ withObject:NULL];
		}
	}
}

@end
