//
//  Vector.m
//  Creatures
//
//  Created by Lenka on 21/12/2009.
//  Copyright 2009 Lenka Pitonakova. All rights reserved.
//

#import <OpenGLES/ES1/glext.h>

#import "Vector.h"
#import "Constants.h"

CGPoint ConvertPointToLocalCoordins (CGFloat orientation_,CGPoint vector_){
	CGPoint tempVec;
	tempVec.x = vector_.x*cos((orientation_+90)*PI/180) + vector_.y*sin((orientation_+90)*PI/180);
	tempVec.y = - vector_.x*sin((orientation_+90)*PI/180) + vector_.y*cos((orientation_+90)*PI/180);
	return tempVec;
}


CGPoint SubtractVectors(CGPoint vec1,CGPoint  vec2) {
	CGPoint result;
	result.x=vec1.x-vec2.x;
	result.y=vec1.y-vec2.y;
	return result;
}
CGPoint AddVectors(CGPoint vec1,CGPoint  vec2) {
	CGPoint result;
	result.x=vec1.x+vec2.x;
	result.y=vec1.y+vec2.y;
	return result;
}

CGPoint NormalizeVector(CGPoint vec_) {
	CGPoint vec = vec_;
	float tolerance = 0.0001;
	float m = sqrt((vec.x* vec.x) + (vec.y*vec.y));
	if (m <= tolerance) {m=1;}
	vec.x /=m;
	vec.y /=m;
		
	if (fabs(vec.x) < tolerance){vec.x = 0;}
	if (fabs(vec.y) < tolerance){vec.y = 0;}
	
	return vec;
}
	
